/******************************************************************************/
/*									      */
/* [PSXg[ANZXvOC]					      */
/*									      */
/*	FILE NAME	: Plugin.c   					      */
/*	FUNCTION	: WSTRANZX (t@Cp)			      */
/*									      */
/*	FUNCTIONS		| an outline				      */
/*    --------------------------+-------------------------------------------- */
/*	PsrQueryPlugin()	| vOC̎擾			      */
/*	PsrIsSupportFile()	| Xg[t@C̃T|[g	      */
/*	PsrGetStrFileInfo()	| Xg[t@C̎擾		      */
/*	PsrOpenFile()		| Xg[t@C̃I[v		      */
/*	PsrClose()		| Xg[f[^̃N[Y		      */
/*	PsrRead()		| Xg[f[^̓ǂݎ		      */
/*	PsrSeek()		| ǂݎʒu̐ݒ			      */
/*									      */
/*	HISTORY		| Comment				| Name	      */
/*    ------------------+---------------------------------------+------------ */
/*	2000.01.21	| VK쐬				| ӂ      */
/*	2000.05.09	| CDT|[ĝߑSʏC		| ӂ      */
/*	2000.07.06	| BSwb_`FbN (FF7Ή)	1.01	| ӂ      */
/*	2000.07.11	| PSRPLUGIN\̂̕ύX		1.10	| ӂ      */
/*	2000.07.12	| TvO[g̔	1.10	| ӂ      */
/*	2000.07.15	| t[[gF		1.11	| ӂ      */
/*	2000.07.16	| I[fBI		1.11	| ӂ      */
/*	2000.07.19	| t[[g7.5	1.12	| ӂ      */
/*	2000.10.28	| vOCdlύX		1.20	| ӂ      */
/*	2000.12.03	| IKI`̃T|[g		1.21	| ӂ      */
/*									      */
/*			(C) Copyright ӂ 2000. All rights reserved.       */
/******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <Windows.h>

#include "PSRP.h"


#define _MaxSEARCH		24					// 1.01


typedef struct {	// STRt@C̃wb_[\ ---------------------------
	CHAR		achRiff[4];		// 'RIFF'
	BYTE		abDummy[0x28];
} _TSTRHEADER;
 

typedef struct {	// ZN^[\ ----------------------------------------
	BYTE		abSync[12];		// CD-ROM XA 
	BYTE		abHeader[4];		// CD-ROM XA wb_[
	BYTE		abSubHeader[8];		// CD-ROM XA TuEwb_[
						//  [01014280]x2 or [01016400]x2
	USHORT		usStatus;		// 0110 xxxx xxxx VVVV  ex:6001
						//	x : Reserved for system
						//	V : Version
	USHORT		usDataType;		// S--- ---- ---- ----	ex:8001
						//  S : 1=system-defained format
						//      0=user-defained format
	USHORT		usSectorNo;		// ZN^[ԍ	0`
	USHORT		usNumSector;		// ZN^[ / t[
	ULONG		ulFrameNo;		// t[ԍ	1`
	ULONG		ulLength;		// t[̃f[^
	USHORT		usWidth;		// C[W
	USHORT		usHeight;		// C[W
	ULONG		ulMovieHeadM;		// Reserved for system
	ULONG		ulMovieHeadV;		// Reserved for system
	ULONG		ulReserved;		// 0000 fixed
	USHORT		ausMovie[0x3F0];
	BYTE		abEdc[4];		// CD-ROM XA EDC
	BYTE		abEcc[276];		// CD-ROM XA ECC
} _TSECTOR;


typedef struct {	// Xg[nh̓e ----------------------------
	HANDLE		hFile;		// t@Cnh
	DWORD		nAllSector;	// ZN^
	DWORD		nNumSector;	// cZN^
	DWORD		nNumFrame;	// t[
	DWORD		nFrameRate;	// t[[g	* 10
	DWORD		dwAudio;	// I[fBIޔ
	BYTE		abAudio[0x900*2]; // I[fBIޔobt@
} _THANDLE, *_PTHANDLE;

/******************************************************************************/
/*									      */
/*	PsrQueryPlugin() : vOC̎擾				      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrQueryPlugin(
	LPPSRPLUGIN	lpPlugin)	// vOC擾obt@AhX
{
	strcpy(lpPlugin->aName,      "STR file");
	strcpy(lpPlugin->aCopyright, "Copyright (c) Fyiro 2000.");
	lpPlugin->usVersion	     = 121;			// 1.10
	lpPlugin->usIsSupportVersion = 0;			// 1.10
	lpPlugin->usSystemVersion    = PSR_SYSTEMVERSION;	// 1.10
	strcpy(lpPlugin->aSiteName, "Fyiro's Garage");		// 1.20
	strcpy(lpPlugin->aSiteUrl, "http://homepage2.nifty.com/~mkb/");	// 1.20
}



/******************************************************************************/
/*									      */
/*	PsrIsSupportFile() : Xg[t@C̃T|[g		      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrIsSupportFile(
	LPCTSTR		lpFileName)	// t@C
{
	HANDLE		hFile;
	DWORD		dwRead;
	_TSTRHEADER	strHeader;
	_TSECTOR	sector;
	INT		iPos;						// 1.01


	if(GetFileAttributes(lpFileName) & FILE_ATTRIBUTE_DIRECTORY) {
		return FALSE;
	}

			// w肳ꂽt@CI[v --------------------
	hFile = CreateFile(lpFileName, GENERIC_READ,
			FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
	if(hFile == INVALID_HANDLE_VALUE)	return FALSE;

			// 'RIFF'wb_[̃`FbN ----------------------------
	ReadFile(hFile, &strHeader, sizeof(strHeader), &dwRead, 0);
	if(memcmp(strHeader.achRiff, "RIFF", 4) != 0) {
		CloseHandle(hFile);
		return FALSE;
	}

			// ̃`FbN --------------------------------------
			//	Xe[^XR[h ?
			//	f[^^CvVXe`tH[}bg ?
			//	C[W̃TCY傫Ȃ ?
			//	擪ZN^[f[^ ?
	if(!ReadFile(hFile, &sector, sizeof(sector), &dwRead, 0)) {
		CloseHandle(hFile);
		return FALSE;
	}
	CloseHandle(hFile);

	if(dwRead != sizeof(sector))		return FALSE;
	if(sector.abSubHeader[2] == 0x64)	return FALSE;
	if(!sector.usStatus)			return FALSE;

	if(sector.usStatus & 0x00f0 != 0x0060)	return FALSE;
	if(!(sector.usDataType & 0x8000))	return FALSE;
	if(sector.usNumSector > 24)		return FALSE;

	for(iPos=0; iPos<_MaxSEARCH; iPos++) {				// 1.01
		if(sector.ausMovie[iPos+1] == 0x3800)	break;		// 1.01
	}								// 1.01
	if(sector.ausMovie[iPos+1] != 0x3800)	return FALSE;		// 1.01
	if(sector.ausMovie[iPos+3] > 3) {			// 1.21 ------->
		if(sector.ausMovie[iPos+2] != sector.usWidth) return FALSE;
		if(sector.ausMovie[iPos+3] != sector.usHeight) return FALSE;
	}							// <------- 1.21

	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrGetStrFileInfo() : Xg[t@C̎擾		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrGetStrFileInfo(
	LPCTSTR		lpFileName,	// t@C
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	HANDLE		hFile;
	DWORD		dwRead, dwSize, dwNumSector;
	DWORD		dwNumAudio, dwNumMovie, dwSecCount, dwLength;
	DWORD		dwNumMBlock, dwResolution, nAudioPct;		// 1.10
	DWORD		nNumFrame, nTimeAudio;				// 1.11
	WORD		wResolution, wLength, wRate;			// 1.12
	BYTE		bAudioSubH;					// 1.10
	SIZE		szFrame;
	_TSECTOR	sector;


			// w肳ꂽt@CI[v --------------------
	hFile = CreateFile(lpFileName, GENERIC_READ,
			FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
	if(hFile == INVALID_HANDLE_VALUE)	return FALSE;

	SetFilePointer(hFile, sizeof(_TSTRHEADER), NULL, FILE_BEGIN);

			// ZN^[߂ ----------------------------------
	dwSize = GetFileSize(hFile, NULL) - sizeof(_TSTRHEADER);
	dwNumSector = dwSize / sizeof(_TSECTOR);

			// 擪nt[̃ZN^[ǂݎĕKvȏW
	dwNumAudio = dwNumMovie = nAudioPct = nNumFrame = 0;		// 1.11
	while(1) {
		if(!ReadFile(hFile, &sector, sizeof(sector), &dwRead, 0)) break;
		if(dwRead != sizeof(sector))	break;

		if(sector.abSubHeader[2] == 0x64) {
			dwNumAudio ++;
			bAudioSubH = sector.abSubHeader[3];		// 1.10
			if(!nAudioPct) {				// 1.10
				nAudioPct = dwNumAudio + dwNumMovie;	// 1.10
			}						// 1.10
			continue;
		}
		if(sector.usStatus && sector.ulFrameNo > 30)	break;

		dwNumMovie ++;
		if(!sector.usStatus)		continue;
		if(sector.usSectorNo == 0 && sector.ulFrameNo) {
			szFrame.cx = sector.usWidth;
			szFrame.cy = sector.usHeight;
			nNumFrame = sector.ulFrameNo;			// 1.11
		}
	}
	CloseHandle(hFile);

			// LȃZN^[Ȃ(G[) ------------------------
	if(!dwNumMovie)	return FALSE;

			// Xg[f[^ݒ --------------------------
	dwNumMBlock = ((szFrame.cx + 15) / 16) * ((szFrame.cy + 15) / 16);
	dwResolution= 90000 / dwNumMBlock;
	if(dwResolution < 150)		wResolution = 75;
	else if(dwResolution < 300)	wResolution = 150;
	else if(dwResolution < 600)	wResolution = 300;
	else				wResolution = 600;

	dwLength = dwNumMovie * sizeof(sector.ausMovie) / nNumFrame;	// 1.11
	if(dwLength > 20 * 1024)		wLength = 75;
	else if(dwLength > 10 * 1024)		wLength = 150;
	else if(dwLength >  5 * 1024)		wLength = 300;
	else					wLength = 600;

	dwSecCount = dwNumAudio + dwNumMovie;
	lpStreamInfo->wTypeFlags    = PSR_STRTYPE_MOVIE;
	lpStreamInfo->wReserved	    = 0;
	lpStreamInfo->nBeginSector  = 0;
	lpStreamInfo->nNumSector    = 0;
	lpStreamInfo->nNumFrame	    = (dwNumSector * nNumFrame) / dwSecCount;
	lpStreamInfo->szFrame	    = szFrame;
	lpStreamInfo->wFrameRate    = min(wResolution, wLength);
	if(dwNumAudio) {
		lpStreamInfo->wTypeFlags	|= PSR_STRTYPE_AUDIO;
		lpStreamInfo->wFormatTag	= WAVE_FORMAT_PCM;
		lpStreamInfo->wBitsPerSample	= 16;
		lpStreamInfo->wChannels		=			// 1.11
				(bAudioSubH & 0x01) ? 2 : 1;		// 1.11
		lpStreamInfo->nSamplesPerSec	=			// 1.11
				(bAudioSubH & 0x04) ? 18900:37800;	// 1.11
	}
	else {
		lpStreamInfo->wFormatTag	= 0;
		lpStreamInfo->wChannels		= 0;
		lpStreamInfo->nSamplesPerSec	= 0;
		lpStreamInfo->wBitsPerSample	= 0;
	}

	if(dwNumAudio) {// t[[g␳ ---------------------------- 1.12
		nTimeAudio = (dwNumAudio * 40320) /
				(lpStreamInfo->wChannels *
					(lpStreamInfo->nSamplesPerSec / 100));
		wRate = (WORD)((nNumFrame * 10000) / nTimeAudio);
		if(abs((INT)lpStreamInfo->wFrameRate - (INT)wRate) > 20){
			lpStreamInfo->wFrameRate = ((wRate + 2) / 5) * 5;
		}
	}
	lpStreamInfo->nPlayTime	= (lpStreamInfo->nNumFrame * 10000) /
					lpStreamInfo->wFrameRate;

	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrOpenFile() : Xg[t@C̃I[v			      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrOpenFile(
	LPCTSTR		lpFileName,	// t@C
	LPPSRSTREAMINFO	lpStreamInfo)	// Xg[f[^
{
	_PTHANDLE	phandle;


			// nh쐬 --------------------------------------
	if(!(phandle = malloc(sizeof(_THANDLE))))	return NULL;
	phandle->hFile		= NULL;
	phandle->nAllSector	= 0;
	phandle->nNumSector	= 0;
	phandle->nNumFrame	= lpStreamInfo->nNumFrame;
	phandle->nFrameRate	= lpStreamInfo->wFrameRate;
	phandle->dwAudio	= 0;

			// t@CI[v ------------------------------
	phandle->hFile = CreateFile(lpFileName, GENERIC_READ,
			FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
	if(phandle->hFile == INVALID_HANDLE_VALUE) {
		free(phandle);
		return NULL;
	}
	SetFilePointer(phandle->hFile, sizeof(_TSTRHEADER), NULL, FILE_BEGIN);

	phandle->nAllSector = GetFileSize(phandle->hFile, NULL);
 	phandle->nAllSector -= sizeof(_TSTRHEADER);
	phandle->nAllSector /= sizeof(_TSECTOR);
	phandle->nNumSector = phandle->nAllSector;

	return phandle;
}



/******************************************************************************/
/*									      */
/*	PsrClose() : Xg[f[^̃N[Y				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrClose(
	HANDLE		hStream)	// Xg[nh
{
	_PTHANDLE	phandle;


	phandle = hStream;
	CloseHandle(phandle->hFile);
	free(phandle);
	return TRUE;
}

/******************************************************************************/
/*									      */
/*	PsrRead() : Xg[f[^̓ǂݎ				      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrRead(
	HANDLE		hStream,	// Xg[nh
	LPPSRREADBUFF	lpBuffer)	// ǂݎobt@
{
	_PTHANDLE	phandle;
	_TSECTOR	sector;
	DWORD		dwRead;
	INT		iSize, iLength, iPos;				// 1.01
	PBYTE		pbBuffer;


	phandle = hStream;
	memset(lpBuffer, 0, sizeof(PSRREADBUFF) - PSR_FRAMEBUFFER);

			// ޔI[fBIobt@̓eݒ ------------------
	if(phandle->dwAudio) {
		lpBuffer->nLength = phandle->dwAudio;
		memcpy(lpBuffer->abData, phandle->abAudio, phandle->dwAudio);
		phandle->dwAudio = 0;
		return TRUE;
	}

	iLength = 0;	// t@CǂݍŐݒ --------------------------
	while(phandle->nNumSector) {
		if(!ReadFile(phandle->hFile, &sector, sizeof(sector), &dwRead, 0))	break;
		if(dwRead != sizeof(sector))	break;

		phandle->nNumSector --;

				// I[fBIf[^ - - - - - - - - - - - - - -
		if(sector.abSubHeader[2] == 0x64) {
			if(!lpBuffer->nFrameNo) {
				lpBuffer->nLength = 0x900;
				memcpy(lpBuffer->abData,
					&sector.usStatus, lpBuffer->nLength);
				return TRUE;
			} else {
				if(phandle->dwAudio >= 0x900 * 2) continue;
				memcpy(&phandle->abAudio[phandle->dwAudio],
					&sector.usStatus, 0x900);
				phandle->dwAudio += 0x900;
				continue;
			}
		}

				// f[^ - - - - - - - - - - - - - - - - -
		if(!sector.usStatus)	continue;
		if(!sector.ulFrameNo)	continue;

		iPos = 0;	// 擪ZN^[ - - - - - - - - - - - - - - - -
		if(!sector.usSectorNo) {
			lpBuffer->nFrameNo	= sector.ulFrameNo;
			lpBuffer->szFrame.cx	= sector.usWidth;
			lpBuffer->szFrame.cy	= sector.usHeight;
			iLength	= (INT)sector.ulLength;
			pbBuffer= lpBuffer->abData;
			for(iPos=0; iPos<_MaxSEARCH; iPos++) {	// 1.01 ------->
				if(sector.ausMovie[iPos+1] == 0x3800)	break;
			}					// <------- 1.01
		}

		if(iLength) {	// C[Wf[^̃Rs[ - - - - - - - - - - -
			iSize = sizeof(sector.ausMovie) -		// 1.01
					(sizeof(USHORT) * iPos);	// 1.01
			iSize = min(iSize, iLength);			// 1.01
			memcpy(pbBuffer, &sector.ausMovie[iPos], iSize);// 1.01
			pbBuffer += iSize;
			iLength	-= iSize;
			lpBuffer->nLength += iSize;
		}

				// ŏIZN^[ - - - - - - - - - - - - - - - -
		if(sector.usSectorNo == sector.usNumSector - 1) {
			return TRUE;
		}
	}
	return FALSE;
}

/******************************************************************************/
/*									      */
/*	PsrSeek() : ǂݎʒu̐ݒ					      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrSeek(
	HANDLE		hStream,	// Xg[nh
	DWORD		dwPosition)	// ǂݎʒu		1/1000bP
{
	_PTHANDLE	phandle;
	LONG		lFrame, lSector, lPos;


	phandle	= hStream;
	lFrame	= (dwPosition * phandle->nFrameRate) / 10000;
	lSector	= (lFrame * phandle->nAllSector) / phandle->nNumFrame;
	lPos	= lSector * sizeof(_TSECTOR) + sizeof(_TSTRHEADER);

	if(SetFilePointer(phandle->hFile, lPos, NULL, FILE_BEGIN) == 0xffffffff) {
		return FALSE;
	}

	phandle->dwAudio = 0;
	phandle->nNumSector = phandle->nAllSector - lSector;
	return TRUE;
}
